//
//      SGXAWSParser.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.5
//

#ifndef __SGXAWSPARSER_HPP
#define __SGXAWSPARSER_HPP

#include <SophiaFramework.hpp>
#include "SGRErrorDialogSet.hpp"

// {
SFMTYPEDEFSTRUCT(ItemAttributesRec)
struct ItemAttributesRec {
	SFXAnsiString binding;				// {̎
	SFXProperty creator;				// 
	SInt32 amount;						// li
	SFXAnsiString currencyCode;			// ʉݒP
	SFXAnsiString formattedPrice;		// z
	SInt32 numberOfPages;				// y[W
	SInt32 packageDimensionsLength;		// 
	SInt32 packageDimensionsWidth;		// 
	SFXAnsiString productGroup;			// {
	SFXDate publicationDate;			// 
	SFXAnsiString publisher;			// oŎ
};

// 摜	
SFMTYPEDEFSTRUCT(ImageUrlRec)
struct ImageUrlRec {
	SFXAnsiString smallImageURL;		// JPG t@C URL
	SInt32 smallImageHeight;            // 摜̍ (sNZP)
	SInt32 smallImageWidth;				// 摜̕ (sNZP)
	SFXAnsiString mediumImageURL;		// JPG t@C URL
	SInt32 mediumImageHeight;			// 摜̍ (sNZP)
	SInt32 mediumImageWidth;			// 摜̕ (sNZP)
	SFXAnsiString largeImageURL;		// JPG t@C URL
	SInt32 largeImageHeight;			// 摜̍ (sNZP)
	SInt32 largeImageWidth;				// 摜̕ (sNZP)
};

// r[( e )
SFMTYPEDEFSTRUCT(ReviewRec)
struct ReviewRec {
	SFXAnsiString asin;					// ISBN ԍ
	SInt32 rating;						// rA[̕]
	SInt32 helpfulVotes;				// ]l
	SFXAnsiString customerId;			// customer Id
	SInt32 totalVotes;					// g[^̓[l
	SFXDate date;						// r[t
	SFXAnsiString summary;				// Tv
	SFXAnsiString content;				// e
};

// r[( Tv )
SFMTYPEDEFSTRUCT(CustomerReviewsRec)
struct CustomerReviewsRec {
	SInt32 avarageRating;				// ϕ]
	SInt32 totalReviews;				// r[l
	SInt32 totalReviewPages;			// r[y[W
	SFXArray<ReviewRecPtr> reviews;		// r[e
};

// ގi( e )
SFMTYPEDEFSTRUCT(SimilarProductRec)
struct SimilarProductRec {
	SFXAnsiString asin;					// ISBN ԍ
	SFXAnsiString title;				// ^Cg
};

// ގi( Tv )
SFMTYPEDEFSTRUCT(SimilarProductsRec)
struct SimilarProductsRec {
	SFXArray<SimilarProductRecPtr> similarProducts;	// ގi( e )
};

// Not yet implimentation.
SFMTYPEDEFSTRUCT(OfferSummaryRec)
struct OfferSummaryRec {
	SInt32 lowestNewPrice;				
	SFXAnsiString currencyCode;			
	SFXAnsiString formattedPrice;		
	SInt32 totalNew;					
	SInt32 totalUsed;					
	SInt32 totalCollectible;			
	SInt32 totalRefurbished;
};
 
// Not yet implimentation.
SFMTYPEDEFSTRUCT(OfferRec)
struct OfferRec {
	SFXAnsiString merchantId;
	SFXAnsiString condition;
	SFXAnsiString offerListingId;
	SInt32 amount;
	SFXAnsiString CurrencyCode;
	SFXAnsiString formattedPrice;
};

// Not yet implimentation.
SFMTYPEDEFSTRUCT(OffersRec)
struct OffersRec {
	SInt32 totalOffers;
	SInt32 totalOfferspages;
	SFXArray<OfferRecPtr> offers;
};
  
// Not yet implimentation.
SFMTYPEDEFSTRUCT(BrowserNodesRec)
struct BrowserNodesRec {
	SFXAnsiString dummy;
};

// Not yet implimentation.
SFMTYPEDEFSTRUCT(ListmaniaListsRec)
struct ListmaniaListsRec {
	SFXAnsiString dummy;
};

//AWS(Amazon Web Services)  XML X|X͂NX
SFMTYPEDEFCLASS(SGXAWSParser)
class SGXAWSParser {
SFMSEALCOPY(SGXAWSParser)
public:
private:
    Bool					_isParseItemAttributes;
    Bool					_isParseImageUrl;
    Bool					_isParseOfferSummary;
    Bool					_isParseOffers;
    Bool					_isParseCustomerReviews;
    Bool					_isParseSimilarProducts;
    Bool					_isParseBrowserNodes;
    Bool					_isParseListmaniaLists;

    SFXAnsiString			_asin;
    SFXAnsiString			_detailPageURL;
    SFXAnsiString			_title;
    SInt32					_salesRank;

	// ߖ̂߃|C^Ƃĕێ
    ItemAttributesRecPtr	_itemAttributes;
    ImageUrlRecPtr			_imageUrl;
    OfferSummaryRecPtr		_offerSummary;
    OffersRecPtr			_offers;
    CustomerReviewsRecPtr	_customerReviews;
    SimilarProductsRecPtr	_similarProducts;
    BrowserNodesRecPtr		_browserNodes;
    ListmaniaListsRecPtr	_listmaniaLists;

public:
    SGXAWSParser(Void);
    virtual ~SGXAWSParser(Void);
    
	static SFXAnsiString GetUrlForISBNSsarch(SFXAnsiStringConstRef isbn);
    
    Void SetParseImageUrl(Bool param) { _isParseImageUrl = param; }
    Void SetParseCustomerReviews(Bool param) { _isParseCustomerReviews = param; }
    Void SetParseSimilarProducts(Bool param) { _isParseSimilarProducts = param; }
 
public:
    SFXAnsiStringConstRef GetAsin(Void) { return _asin; }
    SFXAnsiStringConstRef GetTitle(Void) { return _title; }

    ItemAttributesRecConstPtr GetItemAttributes(Void) { return _itemAttributes; }
    ImageUrlRecConstPtr GetImageUrl(Void) { return _imageUrl; }
    CustomerReviewsRecConstPtr GetCustomerReviews(Void) { return _customerReviews; }
    SimilarProductsRecConstPtr GetSimilarProducts(Void) { return _similarProducts; }

	Void Clear();

	SFCError Parse(SFXPathConstRef filename);
	SFCError ParseItemAttributes(SFXXMLNodePtr node);
    SFCError ParseTitle(SFXXMLNodePtr node);
    SFCError ParseSmallImage(SFXXMLNodePtr node);
    SFCError ParseMediumImage(SFXXMLNodePtr node);
    SFCError ParseLargeImage(SFXXMLNodePtr node);
    SFCError ParseOfferSummary(SFXXMLNodePtr node);
    SFCError ParseOffers(SFXXMLNodePtr node);
    SFCError ParseCustomerReviews(SFXXMLNodePtr node);
    SFCError ParseSimilarProducts(SFXXMLNodePtr node);
    SFCError ParseBrowserNodes(SFXXMLNodePtr node);
    SFCError ParseListmaniaLists(SFXXMLNodePtr node);
};

#endif // __SGXAWSPARSER_HPP //
